//----------------------------------------------------------------------------
//  Project SpecialFX
//  
//  Copyright  1997. All Rights Reserved.
//
//  SUBSYSTEM:    SpecialFX Application
//  FILE:         specialfxapp.cpp
//  AUTHOR:       
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TSpecialFXApp (TApplication).
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include <stdio.h>

#include "specialfxapp.h"
#include "specialfxdlgclient.h"                        // Definition of client class.


//{{TSpecialFXApp Implementation}}


//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TSpecialFXApp, TApplication)
//{{TSpecialFXAppRSP_TBL_BEGIN}}
  EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
//{{TSpecialFXAppRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TSpecialFXApp
//
TSpecialFXApp::TSpecialFXApp() : TApplication("SpecialFX")
{

  // INSERT>> Your constructor code here.
}


TSpecialFXApp::~TSpecialFXApp()
{
  // INSERT>> Your destructor code here.
}


//--------------------------------------------------------
// TSpecialFXApp
// ~~~~~
// Application intialization.
//
void TSpecialFXApp::InitMainWindow()
{
  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  TSDIDecFrame* frame = new TSDIDecFrame(0, GetName(), 0, false);
  frame->SetFlag(wfShrinkToClient);

  // Assign icons for this application.
  //
  frame->SetIcon(this, IDI_SDIAPPLICATION);
  frame->SetIconSm(this, IDI_SDIAPPLICATION);

  SetMainWindow(frame);

}



//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE1(TSDIDecFrame, TDecoratedFrame)
//{{TSDIDecFrameRSP_TBL_BEGIN}}
//{{TSDIDecFrameRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TSDIDecFrame Implementation}}


TSDIDecFrame::TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection, TModule* module)
:
  TDecoratedFrame(parent, title, !clientWnd ? new TSpecialFXDlgClient(0) : clientWnd, trackMenuSelection, module)
{
  // INSERT>> Your constructor code here.

}


TSDIDecFrame::~TSDIDecFrame()
{
  // INSERT>> Your destructor code here.

}


//--------------------------------------------------------
// TSpecialFXApp
// ~~~~~~~~~~~
// Menu Help About SpecialFX command
//
void TSpecialFXApp::CmHelpAbout()
{
}



int OwlMain(int , char* [])
{
  TSpecialFXApp   app;
  return app.Run();
}


