//----------------------------------------------------------------------------
//  Project SpecialFX
//  
//  Copyright  1997. All Rights Reserved.
//
//  SUBSYSTEM:    SpecialFX Application
//  FILE:         specialfxapp.h
//  AUTHOR:       
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TSpecialFXApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(specialfxapp_h)              // Sentry, use file only if it's not already included.
#define specialfxapp_h

#include <owl/applicat.h>
#include <owl/decframe.h>
#include <owl/opensave.h>


#include "specialfxapp.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();

//{{TSDIDecFrameRSP_TBL_BEGIN}}
  protected:
//{{TSDIDecFrameRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TSDIDecFrame);
};    //{{TSDIDecFrame}}


//{{TApplication = TSpecialFXApp}}
class TSpecialFXApp : public TApplication {
  private:


  public:
    TSpecialFXApp();
    virtual ~TSpecialFXApp();

//{{TSpecialFXAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
//{{TSpecialFXAppVIRTUAL_END}}

//{{TSpecialFXAppRSP_TBL_BEGIN}}
  protected:
    void CmHelpAbout();
//{{TSpecialFXAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TSpecialFXApp);
};    //{{TSpecialFXApp}}


#endif  // specialfxapp_h sentry.
