//----------------------------------------------------------------------------
//  Project SpecialFX
//
//  Copyright  1997. All Rights Reserved.
//
//  SUBSYSTEM:    SpecialFX Application
//  FILE:         specialfxdlgclient.h
//  AUTHOR:
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TSpecialFXDlgClient (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(specialfxdlgclient_h)              // Sentry, use file only if it's not already included.
#define specialfxdlgclient_h

#include <owl/dialog.h>
#include <owl/slider.h>
#include <owl/checkbox.h>
#include <owl/commctrl.h>

#include "specialfxapp.rh"                  // Definition of all resources.

#include "CWaterRoutine.h"
#include "CFireRoutine.h"
#include "CPlasmaRoutine.h"
#include "CRotateRoutine.h"
#include "CSnowRoutine.h"
#include "CTwirlRoutine.h"
//#include "CDiscoRoutine.h"
//...


//{{TDialog = TSpecialFXDlgClient}}
struct TSpecialFXDlgClientXfer {
//{{TSpecialFXDlgClientXFER_DATA}}
    uint    pCheckBox_Fire;
    uint    pCheckBox_Plasma;
    uint    pCheckBox_Water;
    uint    pCheckBox_Rotate;
    uint    pCheckBox_Twirl;
    uint    pCheckBox_Snow;
//{{TSpecialFXDlgClientXFER_DATA_END}}
};

class TSpecialFXDlgClient : public TDialog {
  public:
    TSpecialFXDlgClient(TWindow* parent, TResId resId = IDD_CLIENT, TModule* module = 0);
    virtual ~TSpecialFXDlgClient();

//{{TSpecialFXDlgClientVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
    virtual void CleanupWindow();
//    virtual void Paint(TDC& dc, bool erase, TRect& rect);
//{{TSpecialFXDlgClientVIRTUAL_END}}

//{{TSpecialFXDlgClientRSP_TBL_BEGIN}}
  protected:
    void OnAnimate();
    void OnStop();
    void OnCheckFire();
    void OnCheckPlasma();
    void OnCheckWater();
    void EvTimer(uint timerId);
    void OnSlideFire();
    void OnSlidePlasma();
    void OnTrackAll_Fire(uint code);
    void OnTrackAll_Plasma(uint code);
    void OnTrackAll_Twirl(uint code);
    void EvMouseMove(uint modKeys, TPoint& point);
    void EvLButtonDown(uint modKeys, TPoint& point);
    void EvPaint();
    void OnAbout();
    void OnCheckRotate();
    void OnCheckSnow();
    void OnCheckTwirl();
//{{TSpecialFXDlgClientRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TSpecialFXDlgClient);

    CWaterRoutine	myWater;
    CFireRoutine	myFire;
    CPlasmaRoutine	myPlasma;
    CRotateRoutine myRotateEffect;
    CTwirlRoutine myTwirlEffect;
//    CSnowRoutine mySnowEffect;

	bool runWater;
	bool runFire;
	bool runPlasma;
   bool runRotate;
	bool runTwirl;
	bool runSnow;

	TDib *bmpRenderSource;
   TDib *bmpRenderTarget;

//{{TSpecialFXDlgClientXFER_DEF}}
  protected:
    TCheckBox* pCheckBox_Fire;
    TCheckBox* pCheckBox_Plasma;
    TCheckBox* pCheckBox_Water;
    THSlider * pTrack_Fire;
    THSlider * pTrack_Plasma;
    TCheckBox* pCheckBox_Rotate;
    TCheckBox* pCheckBox_Twirl;
    THSlider * pTrack_Twirl;
    TCheckBox* pCheckBox_Snow;
//{{TSpecialFXDlgClientXFER_DEF_END}}
};    //{{TSpecialFXDlgClient}}


#endif  // specialfxdlgclient_h sentry.
